## ros-indigo-grasp-planning-graspit 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(grasp_planning_graspit)

# Set BUILD_GRASPIT to true if you would like to 
# downloads (git clone) and build the fork of GraspIt! which
# is required for this package (https://github.com/JenniferBuehler/graspit).
# If BUILD_GRASPIT is set to false, it will search for the package
# "graspit' instead.
# If set to true, you can also use GRASPIT_BRANCH_NAME to select a git branch.
# IMPORTANT: If you set this to false and are compiling
# with catkin, uncomment the <*_depend> tags relating to
# graspit in package.xml!
if (NOT DEFINED BUILD_GRASPIT)
    set (BUILD_GRASPIT true)
endif (NOT DEFINED BUILD_GRASPIT)

###################################################
## Define cmake variables to build with/without catkin 
###################################################


# By default, compiling with catkin is
# enabled. It will only be disabled again
# if CATKIN_DEVEL_PREFIX is not set.
# To enforce compiling *with* catkin
# even if CATKIN_DEVEL_PREFIX is not defined,
# compile with the flag -DENFORCE_CATKIN=true
# This is for example required when compiling on jenkins,
# when it seems that CATKIN_DEVEL_PREFIX is not set.
# So set ENFORCE_CATKIN to true only for the commits
# to jenkins.
set (ENFORCE_CATKIN true)
   
# Private flag: compiling with catkin is prioritized by default.
# This flag will be set to false if CATKIN_DEVEL_PREFIX
# is empty/not defined, **and** ENFORCE_CATKIN is false.
set (COMPILE_WITH_CATKIN true)

if (NOT ENFORCE_CATKIN AND NOT CATKIN_DEVEL_PREFIX)
    message(STATUS "Compiling grasp_planning_graspit: CATKIN_DEVEL_PREFIX is not defined, so **enforcing compilation with cmake**.")
    set (COMPILE_WITH_CATKIN false)
endif (NOT ENFORCE_CATKIN AND NOT CATKIN_DEVEL_PREFIX)

if (COMPILE_WITH_CATKIN)
  find_package(catkin REQUIRED COMPONENTS eigen_conversions roslint) 
endif (COMPILE_WITH_CATKIN)
   
# Configuration file for graspit
set (GRASP_PLANNNIG_GRASPIT_CONFIG_CMAKE grasp_planning_graspitConfig.cmake)

# CMake module path
set (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeMacros/")

# if catkin is not used, or graspit built locally,
# we have to get the Eigen/graspit dependencies separately
if (NOT COMPILE_WITH_CATKIN OR NOT BUILD_GRASPIT)
    if (NOT BUILD_GRASPIT)
        message(STATUS "Finding graspit...")
        find_package(graspit REQUIRED)
    endif (NOT BUILD_GRASPIT)
    find_package(Eigen3 REQUIRED)
endif (NOT COMPILE_WITH_CATKIN OR NOT BUILD_GRASPIT)

find_package(Boost REQUIRED COMPONENTS filesystem system thread program_options)

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
    # can check with if (TARGET doc) whether the target 'doc' was already used for another package.
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(grasp_planning_graspit_doc
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
endif(DOXYGEN_FOUND)
   
# Target dependencies to graspit: defaults to whole
# graspit package and can be overwritten if graspit is build locally.
set(GRASPIT_TARGET_DEPS graspit)

# if the graspit fork should be build with this package, pull graspit 
# from external and build locally without installing
if (BUILD_GRASPIT)
    if (NOT DEFINED GRASPIT_BRANCH_NAME)
        set (GRASPIT_BRANCH_NAME master)
    endif (NOT DEFINED GRASPIT_BRANCH_NAME)
    message(STATUS "Building graspit library, will clone git repository. Branch name: ${GRASPIT_BRANCH_NAME}")

    ####
    # Download and unpack graspit at configure time.
    # The advantage of doing this at configure time, and then build
    # the graspit source as sub-package, is that the requierd variables
    # (include/link directories and libraries) can be used. Only
    # adding graspit as external package will not allow us to access the
    # config files (as for example resulting from find_package())
    ####

    # set the environment variables for the graspit_external/CMakeLists-external-graspit.txt
    set (GRASPIT_REPO_NAME graspit)
    set (GRASPIT_GIT "https://github.com/JenniferBuehler/graspit")
    set (GRASPIT_BRANCH_NAME "master")
    set (GRASPIT_DL_DIR ${CMAKE_CURRENT_BINARY_DIR}/graspit_external)
    set (GRASPIT_INSTALL_DIR ${GRASPIT_DL_DIR}/install)
    set (GRASPIT_BUILD_DIR ${GRASPIT_DL_DIR}/graspit-build)
    
    # message("Using binary dir ${CMAKE_CURRENT_BINARY_DIR}")

    # Copy the external cmake file to the build directory for graspit.
    # first generate the cmakelists: this copies from the source directory to the build directory
    configure_file(graspit_external/CMakeLists-external-graspit.txt ${GRASPIT_DL_DIR}/CMakeLists.txt)
    # This clones the repository and runs the cmake configure step.
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
        WORKING_DIRECTORY ${GRASPIT_DL_DIR})
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
        WORKING_DIRECTORY ${GRASPIT_DL_DIR})
  
    # convenience variable: this is where all the graspit source is after download step. 
    set (GRASPIT_SRC_DIR ${GRASPIT_DL_DIR}/repo/${GRASPIT_REPO_NAME})

    # Back up variables and change them for add_subdirectory().
    # It would be nice to completely build graspit entirely by
    # an external project, but in order to avoid building
    # at configure time, and still have access to cmake
    # variables as graspit_LIBRARIES, this solution was found best.
    set (_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}) 
    set (_CATKIN_DEVEL_PREFIX ${CATKIN_DEVEL_PREFIX})
    set (_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
    set (_ENFORCE_CATKIN ${ENFORCE_CATKIN})
    set (_LIBRARY_OUTPUT_PATH ${LIBRARY_OUTPUT_PATH})
    set (_EXECUTABLE_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
    # change the values for the subdirectory
    set (CMAKE_INSTALL_PREFIX ${GRASPIT_INSTALL_DIR})
    set (CATKIN_DEVEL_PREFIX false)
    # output paths need to be set as well to prevent installation into catkin devel space
    set (LIBRARY_OUTPUT_PATH ${GRASPIT_BUILD_DIR})
    set (EXECUTABLE_OUTPUT_PATH ${GRASPIT_BUILD_DIR})
    set (BUILD_SHARED_LIBS false) # we will compile the code into the grasp_planning_graspit library
    set (BUILD_TESTS false)
    set (ENFORCE_CATKIN false)

    # Add the external graspit build directory to our build, and set the build directory.
    add_subdirectory(${GRASPIT_SRC_DIR}
        ${GRASPIT_BUILD_DIR} EXCLUDE_FROM_ALL)
   
    # restore old variables 
    set (CMAKE_INSTALL_PREFIX ${_CMAKE_INSTALL_PREFIX}) 
    set (CATKIN_DEVEL_PREFIX ${_CATKIN_DEVEL_PREFIX})
    set (BUILD_SHARED_LIBS ${_BUILD_SHARED_LIBS})
    set (LIBRARY_OUTPUT_PATH ${_LIBRARY_OUTPUT_PATH})
    set (EXECUTABLE_OUTPUT_PATH ${_EXECUTABLE_OUTPUT_PATH})
    set (ENFORCE_CATKIN ${_ENFORCE_CATKIN})
    
    # get the relevant cmake variables from the subdirectory
    get_directory_property(graspit_INCLUDE_DIRS
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_INCLUDE_DIRS)
    get_directory_property(graspit_CXXFLAGS
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_CXXFLAGS)
    get_directory_property(graspit_LINK_DIRS
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_LINK_DIRS)
    get_directory_property(graspit_LIBRARIES
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_LIBRARIES)
    get_directory_property(graspit_SYS_INCLUDES
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_SYS_INCLUDES)
    get_directory_property(graspit_SYS_LIBRARIES
            DIRECTORY ${GRASPIT_SRC_DIR} 
            DEFINITION graspit_SYS_LIBRARIES)

   # overwrite the target dependencies to include the external target 
   set(GRASPIT_TARGET_DEPS graspit_ext graspit graspit_simulator)
endif (BUILD_GRASPIT)

# Find Qt package separately because we'll need it for the wrapper,
# regardless whether it is required by graspit or not
SET( QT_USE_QT3SUPPORT TRUE )
find_package(Qt4 COMPONENTS QtCore REQUIRED)
include (${QT_USE_FILE})

# Qt MOC files are needed ONLY because QT slots are used at the moment in EigenGraspPlanner.h
# Qt include files should be covered by the implicit dependency of graspit libraries
# if compiled with catkin
set (MOC_HEADERS include/grasp_planning_graspit/EigenGraspPlanner.h) 
QT4_WRAP_CPP(MOC_OUTFILES ${MOC_HEADERS})
    
###############################
# Build catkin_package() command
###############################
if (COMPILE_WITH_CATKIN)
    # INCLUDE_DIRS for catkin_package() command

    if (BUILD_GRASPIT)
      set(CATKIN_DEPEND_INCLUDE_DIRS
          include
          ${graspit_SYS_INCLUDES})
    else (BUILD_GRASPIT)
      set(CATKIN_DEPEND_INCLUDE_DIRS
          include
          ${graspit_INCLUDE_DIRS}
          ${GRASPIT_INCLUDE_DIRS}
          ${EIGEN3_INCLUDE_DIR}
          ${QT_INCLUDES}                                                             
          ${QT_INCLUDE_DIR}
      )    
    endif (BUILD_GRASPIT)
    
    # CATKIN_DEPENDS for catkin_package() command
    set (CATKIN_DEPEND_PKGS eigen_conversions)

    # DEPENDS for catkin_package()
    set(CATKIN_DEPENDS_LIBS Boost SoQt4 Coin Qt4 LAPACK Qhull)

    ###################################
    ## catkin specific configuration ##
    ###################################
    ## The catkin_package macro generates cmake config files for your package
    ## Declare things to be passed to dependent projects
    ## INCLUDE_DIRS: uncomment this if you package contains header files
    ## LIBRARIES: libraries you create in this project that dependent projects also need
    ## CATKIN_DEPENDS: catkin_packages dependent projects also need
    ## DEPENDS: system dependencies of this project that dependent projects also need
    catkin_package(
      INCLUDE_DIRS ${CATKIN_DEPEND_INCLUDE_DIRS} ${QT_INCLUDES}
      LIBRARIES grasp_planning_graspit ${graspit_SYS_LIBRARIES}  # need to add graspit_SYS_LIBRARIES here for bloom binary builds
      CATKIN_DEPENDS ${CATKIN_DEPEND_PKGS} 
      DEPENDS ${CATKIN_DEPENDS_LIBS}
    )
endif (COMPILE_WITH_CATKIN)


###########
## Build ##
###########

# add compiler definitions
add_definitions(${graspit_CXXFLAGS})

# include all directories, inc. catkin related - if any is empty,
# it doesn't matter
set(ALL_INCLUDE_DIRECTORIES
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${graspit_INCLUDE_DIRS}
  ${GRASPIT_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIR}
  ${QT_INCLUDES}                                                             
  ${QT_INCLUDE_DIR}
)

add_definitions(
    ${graspit_CXXFLAGS}
    # -DGRASPITDBG
)

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  ${ALL_INCLUDE_DIRECTORIES}
)

set (INCDIR include/${PROJECT_NAME})
set(MAIN_HEADER_FILES
    ${INCDIR}/GraspItSceneManager.h
    ${INCDIR}/GraspItSceneManagerHeadless.h
    ${INCDIR}/GraspItAccessor.h
    ${INCDIR}/GraspItDatabaseManager.h
    ${INCDIR}/GraspItSimpleDBManager.h
    ${INCDIR}/EigenGraspPlanner.h
    #    ${INCDIR}/EigenGraspPlannerNoQt.h
    ${INCDIR}/EigenGraspResult.h
    ${INCDIR}/GraspItTypes.h
    ${INCDIR}/SharedPtr.h
    ${INCDIR}/ThreadImpl.h
    ${INCDIR}/PrintHelpers.h
    ${INCDIR}/LogBinding.h
)

set(MAIN_SOURCE_FILES 
    ${MOC_OUTFILES} 
    src/GraspItSceneManager.cpp 
    src/GraspItSceneManagerHeadless.cpp 
    src/GraspItAccessor.cpp 
    src/EigenGraspPlanner.cpp 
    #    src/EigenGraspPlannerNoQt.cpp 
    src/EigenGraspResult.cpp 
    src/LogBinding.cpp 
    src/PrintHelpers.cpp 
    src/GraspItHelpers.cpp
    src/GraspItDatabaseManager.cpp
    src/GraspItSimpleDBManager.cpp
)

## Declare a C++ library
add_library(grasp_planning_graspit SHARED
 ${MAIN_SOURCE_FILES} 
)

## Add cmake target dependencies of the library
if (COMPILE_WITH_CATKIN)

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(grasp_planning_graspit)

find_package (grasp_planning_graspit REQUIRED)

include_directories(
    ${grasp_planning_graspit_INCLUDE_DIRS}
)

add_executable(simple_planning_tutorial src/simple_planning_tutorial.cpp)

target_link_libraries(simple_planning_tutorial
   ${grasp_planning_graspit_LIBRARIES}
)

=== debian/changelog ===
ros-indigo-grasp-planning-graspit (1.2.0-0trusty) trusty; urgency=high

  * Update
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Fri, 05 Jan 2018 23:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.3-0trusty) trusty; urgency=high

  * Tested with current version of graspit
  * Adaptation for graspit upstream merge
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Thu, 04 Jan 2018 23:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.1-0trusty) trusty; urgency=high

  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Sat, 06 Aug 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.0-0trusty) trusty; urgency=high

  * New version to work with new update on graspit fork
  * Removed camera parameters setting as this is done in GraspitCore now
  * EGPlanner working with new graspit headless branch
  * Updated command line parsing in grasp_planning.cpp and adjusted some parameters for prismatic joints in urdf2graspit
  * removed more unneeded includes
  * removed unneeded includes
  * removed unneeded includes of ivmgrHeadless.h
  * Added option to change object position and max number of iterations as command line argument in grasp_planning.cpp
  * Now can save planning results without objects -only pose- as well
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Mon, 25 Jul 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (1.0.0-0trusty) trusty; urgency=high

  * Removed direct Qt dependencies from urdf2graspit, as this is now in urdf2inventor
  * Now compiles with new graspit and new urdf2inventor
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Tue, 07 Jun 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.5-0trusty) trusty; urgency=high

  * Added pre-grasp state computation
  * Added helper class EigenGraspPlannerClient and some example grasp results for Jaco
  * Now supports an extra auto-grasp as finalization of planning, and control of how many results are saved
  * Fixed broken hand transform which was returned for resulting grasps
  * Added means to save a Grasp.msg and added a table obstacle
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Fri, 01 Apr 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.3-0trusty) trusty; urgency=high

  * changed catkin_package system depends to names in rosdep
  * Adapted cmake file to for jenkins, and removed c++11 flag, which required fixing two little things in sources
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Mon, 07 Mar 2016 23:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.2-0trusty) trusty; urgency=high



 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Thu, 03 Mar 2016 23:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.0-0trusty) trusty; urgency=high

  * now also adds graspit_simulator_standalone
  * graspit fork is now compiled into libraries here and doesn't need to be installed separately
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Tue, 01 Mar 2016 23:00:00 -0000

=== debian/control ===
Source: ros-indigo-grasp-planning-graspit
Section: misc
Priority: extra
Maintainer: Jennifer Buehler <jennifer.e.buehler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), git-core, libblas-dev, libboost-all-dev, libcoin80-dev, liblapack-dev, libqhull-dev, libqt4-dev, libsoqt4-dev, ros-indigo-catkin, ros-indigo-eigen-conversions, ros-indigo-roslint
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-grasp-planning-graspit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libblas-dev, libboost-all-dev, libcoin80-dev, liblapack-dev, libqhull-dev, libqt4-dev, libsoqt4-dev, ros-indigo-eigen-conversions
Description: The grasp_planning_graspit package This package.xml file is only required if the source is to be built with catkin.
 You can also build using cmake only, in which case this file is not required.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-grasp-planning-graspit//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
